<template>
  <v-flex
    xs12
    sm8
    offset-sm2
  >
    <v-card
      id="list1"
      class="list"
    >
      <CardDraggable
        v-for="item in list1W"
        :key="item.id"
        :data-list="'list1'"
        :item="item"
      />
    </v-card>
    <v-card
      id="list2"
      class="list"
    >
      <CardDraggable
        v-for="item in list2W"
        :key="item.id"
        :data-list="'list2'"
        :item="item"
      />
    </v-card>
    <v-card
      id="list3"
      class="list"
    >
      <CardDraggable
        v-for="item in list3W"
        :key="item.id"
        :data-list="'list3'"
        :item="item"
      />
    </v-card>
  </v-flex>
</template>

<script>
import interact from 'interactjs'
import _ from 'underscore'
import CardDraggable from '../components/CardDraggable'

export default {
  name: 'App',
  components: {
    CardDraggable
  },
  data () {
    return {
      list1: [{
        id: 1,
        name: 'Moto',
        group: false
      }, {
        id: 2,
        name: 'Mata',
        group: false
      }, {
        id: 3,
        name: 'Mutu',
        group: false
      }],
      list2: [],
      list3: []
    }
  },
  computed: {
    list1W: {
      get () {
        return this.list1
      },
      set (el) {
        this.list1 = el
      }
    },
    list2W: {
      get () {
        return this.list2
      },
      set (el) {
        this.list2 = el
      }
    },
    list3W: {
      get () {
        return this.list3
      },
      set (el) {
        this.list3 = el
      }
    }
  },
  created () {
    interact('.piece').draggable({
      onstart: this.draggableOnStart,
      onmove: this.draggableOnMove,
      onend: this.draggableOnEnd
    })
    interact('.list').dropzone({
      accept: '.piece',
      overlap: 0.75,
      ondropactivate: this.dropzoneOnDropActivate,
      ondragenter: this.dropzoneOnDragEnter,
      ondragleave: this.dropzoneOnDragLeave,
      ondrop: this.dropzoneOnDrop,
      ondropdeactivate: this.dropzoneOnDropDeActivate
    })
  },
  methods: {
    testfunction (number) {
      if (number >= 0) {
        return true
      }
      return false
    },
    draggableOnStart (event) {
      const groups = document.getElementsByClassName('grouped')
      const { target } = event
      // console.log(target)

      if (groups.length == 0 || !target.classList.contains('grouped')) {
        target.classList.add('moving')
      } else {
        for (let index = 0; index < groups.length; index++) {
          const element = groups[index]
          element.classList.add('moving')
        }
      }
    },
    draggableOnMove (event) {
      const groups = document.getElementsByClassName('grouped')
      const { target } = event
      const x = (parseFloat(target.getAttribute('data-x')) || 0) + event.dx
      const y = (parseFloat(target.getAttribute('data-y')) || 0) + event.dy

      if (groups.length == 0 || !target.classList.contains('grouped')) {
        target.style.webkitTransform = target.style.transform = `translate(${x}px, ${y}px)`
        target.setAttribute('data-x', x)
        target.setAttribute('data-y', y)
      } else {
        for (let index = 0; index < groups.length; index++) {
          const element = groups[index]

          const xDiff = target.offsetLeft - element.offsetLeft
          const yDiff = target.offsetTop - element.offsetTop

          element.style.webkitTransform = element.style.transform = `translate(${x + xDiff + index * 5}px, ${y + yDiff + index * 5}px)`
          element.setAttribute('data-x', x)
          element.setAttribute('data-y', y)
        }
      }
    },
    draggableOnEnd (event) {
      const groups = document.getElementsByClassName('grouped')
      const { target } = event
      if (groups.length == 0 || !target.classList.contains('grouped')) {
        target.style.webkitTransform = target.style.transform = ''
        target.setAttribute('data-x', 0)
        target.setAttribute('data-y', 0)
        target.classList.remove('moving')
      } else {
        for (let index = 0; index < groups.length; index++) {
          const element = groups[index]
          element.style.webkitTransform = element.style.transform = ''
          element.setAttribute('data-x', 0)
          element.setAttribute('data-y', 0)
          element.classList.remove('moving')
          element.classList.remove('can-drop')
        }
      }
    },
    dropzoneOnDropActivate (event) {
      event.target.classList.add('drop-active')
    },
    dropzoneOnDragEnter (event) {
      const draggableElement = event.relatedTarget
      const dropzoneElement = event.target
      dropzoneElement.classList.add('drop-target')
      draggableElement.classList.add('can-drop')
    },
    dropzoneOnDragLeave (event) {
      event.target.classList.remove('drop-target')
    },
    dropzoneOnDrop (event) {
      const draggableElement = event.relatedTarget
      const dropzoneElement = event.target
      const endListName = dropzoneElement.getAttribute('id')
      const startListName = draggableElement.getAttribute('data-list')
      const findElement = function (ele) {
        console.log(ele.id)
        if (ele) {
          return ele.id == parseInt(draggableElement.getAttribute('data-id'))
        }
        return {
          id: 0,
          name: 'error',
          group: false
        }
      }
      const element = _.find(this[startListName], findElement)
      const newElement = []
      _.each(_.keys(element), (el) => {
        newElement[el] = element[el]
      })
      if (!_.find(this[endListName], findElement)) {
        this[endListName].push(element)
      }
      console.log(this[endListName])
    },
    dropzoneOnDropDeActivate (event) {
      event.target.classList.remove('drop-active')
      event.target.classList.remove('drop-target')
      event.relatedTarget.classList.remove('can-drop')
    }
  }
}

</script>

<style>
  .list {
    padding: 30px;
    margin: 30px 0;
    min-height: 100px;
    border: 1px solid lightgrey;
    background-color: white !important;
  }

  .drop-active {
    background-color: rgb(46, 155, 155) !important;
  }

  .drop-target {
    background-color: yellowgreen !important;
  }

  .can-drop {
    background-color: lightcoral !important;
  }

</style>
